# -*- coding: utf-8 -*-
import socket
import os


def main():
    """
    Connects to server and sends a function for the server to do
    """
    connected = False
    for i in xrange(5):
        try:
            connected = True
            client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            client_socket.connect(('127.0.0.1', 1729))  # this pc's ip, open
            func = ""                                   # port on this pc
        except socket.error:
            print "server is down"
    if connected:
        while func != "EXIT":

            func = raw_input("enter a function possible functions are:"
                             " SNIP, FILE, DELT, COPY, OPEN, EXIT\n").upper()
            client_socket.send(func)

            if func == "SNIP":
                # builds the image sent by the server
                img = ""
                data = client_socket.recv(1000)
                while data[-4:] != " END":
                    img += data
                    data = client_socket.recv(1000)
                img += data[:-4]
                file = (open("count.txt", "r"))
                num = file.read()  # opens a counter file and
                file.close()       # puts a number next to the
                with open("count.txt", "w") as file:  # screenshot's name
                    file.write(str(int(num) + 1))
                fh = open("Client_Screen{}.png".format(int(num)), "wb")
                fh.write(img.decode('base64'))
                fh.close()

            if func == "FILE":
                # receives and prints all the directories
                path = raw_input("Enter the directory\n")
                if not path:
                    path = "exit"
                is_exist = os.path.exists(path)
                path = r"{:0>4}".format(len(path)) + path
                client_socket.send(path)
                if is_exist:
                    num_files = int(client_socket.recv(4))
                    for i in xrange(num_files):
                        length = int(client_socket.recv(4))
                        print client_socket.recv(length)
                else:
                    print "Directory doesn't exist"

            if func == "DELT":
                # sends a directory address to delete
                path = raw_input("Enter directory to delete\n")
                path = r"{:0>4}".format(len(path)) + path
                client_socket.send(path)
                data = client_socket.recv(3)  # length of message received
                if data == "err":
                    print "Directory doesn't exist"

            if func == "COPY":
                # sends a directory address to delete
                path1 = raw_input("Enter directory of file to copy\n")
                path1 = r"{:0>4}".format(len(path1)) + path1
                client_socket.send(path1)
                path2 = raw_input("Enter directory of file to paste\n")
                path2 = r"{:0>4}".format(len(path1)) + path2
                client_socket.send(path2)
                data = client_socket.recv(3)  # length of message received
                if data == "suc":
                    print "Copied Successfully"
                if data == "err":
                    print "Error. Try again"

            if func == "OPEN":
                path = raw_input("Enter directory or app to open\n")
                path = r"{:0>4}".format(len(path)) + path
                client_socket.send(path)
                data = client_socket.recv(3)  # length of message received
                if data == "suc":
                    print "Successfully Opened"
                if data == "err":
                    print "Error. Try again"

    else:
        print "connection timed out"
    print "client closed"
    file = (open("count.txt", "r"))
    file.close()
    with open("count.txt", "w") as file:
        file.write("1")  # resets the counter
    client_socket.close()


if __name__ == '__main__':
    main()
